<?php
	/*
		Plugin Name: oxyXML generator
		Plugin URI: http://www.oxeron.com/category/open-source/wordpress-plugin-oxyxml
		Description: Generates xml file in order to display your posts on other websites, using PHP or Flash
		Version: 0.2
		Author: Olivier PIERRE
		Author URI: http://www.oxeron.com/
		Contributor: Ludovic ANDRE
        Contributor URI: http://blog.episode-2.com/
	*/
	$oxyXML_version = "0.2";

	add_option('oxyXML_active', true);
	add_option('oxyXML_categories', "");
	add_option('oxyXML_path', "./");	
	add_option('oxyXML_delay', "");	
	add_option('oxyXML_count', "5");
	add_option('oxyXML_export_excerpt', "0");
	add_option('oxyXML_export_content', "0");
	add_option('oxyXML_export_date', "1");
	add_option('oxyXML_export_category_id', "1");	
	add_option('oxyXML_export_category_name', "1");	
	add_option('oxyXML_export_title', "1");	
	add_option('oxyXML_export_url', "1");

				
	$oxyXML_active = get_option('oxyXML_active');
	$oxyXML_categories = get_option('oxyXML_categories');
	$oxyXML_path = get_option('oxyXML_path');
	$oxyXML_delay = get_option('oxyXML_delay');
	$oxyXML_count = get_option('oxyXML_count');
	
	add_action('admin_menu', 'oxyXML_add_pages');
	if ($oxyXML_active) {
		add_action('edit_post', 'oxyXML_generate_xml');
		add_action('delete_post', 'oxyXML_generate_xml');
		add_action('private_to_published', 'oxyXML_generate_xml');
		add_action('publish_page', 'oxyXML_generate_xml');
		add_action('publish_phone', 'oxyXML_generate_xml');
		add_action('publish_post', 'oxyXML_generate_xml');
		add_action('save_post', 'oxyXML_generate_xml');
		add_action('xmlrpc_publish_post', 'oxyXML_generate_xml');
	}

	function oxyXML_add_pages() {
		add_options_page("oxyXML generator", "oxyXML", 8, basename(__FILE__), "oxyXML_admin_page");
	}

	function oxyXML_permissions() {
		$oxyXML_active = get_option('oxyXML_active');		
		$oxyXML_path = ABSPATH . get_option('oxyXML_path');
		$oxyXML_file_path = $oxyXML_path . "posts.xml";		

		if ($oxyXML_active && is_file($oxyXML_file_path) && is_writable($oxyXML_file_path)) $oxyXML_permission = 0;
		elseif ($oxyXML_active && !is_file($oxyXML_file_path) && is_writable($oxyXML_path)) {
			$fp = fopen($oxyXML_file_path, 'w');
			fwrite($fp, "<?xml version=\"1.0\" encoding=\"UTF-8\"?><urlset xmlns=\"http://www.sitemaps.org/schemas/sitemap/0.9\" />");
			fclose($fp);
			if (is_file($oxyXML_file_path) && is_writable($oxyXML_file_path)) $oxyXML_permission = 0;
			else $oxyXML_permission = 1;
		}
		elseif ($oxyXML_active) $oxyXML_permission = 1;
		else $oxyXML_permission = 0;		
		return $oxyXML_permission;
	}


	function oxyXML_generate_xml() {
		global $oxyXML_version, $table_prefix,$msg,$wpdb;		
		$t = $table_prefix;
		$oxyXML_active = get_option('oxyXML_active');		
		$oxyXML_categories = get_option('oxyXML_categories');
		$oxyXML_path = get_option('oxyXML_path');
		$oxyXML_delay = get_option('oxyXML_delay');
		$oxyXML_count = get_option('oxyXML_count');
		$oxyXML_export_excerpt = get_option('oxyXML_export_excerpt');
		$oxyXML_export_content = get_option('oxyXML_export_content');
		$oxyXML_export_date = get_option('oxyXML_export_date');
		$oxyXML_export_title = get_option('oxyXML_export_title');		
		$oxyXML_export_category_id = get_option('oxyXML_export_category_id');				
		$oxyXML_export_category_name = get_option('oxyXML_export_category_name');
		$oxyXML_export_url = get_option('oxyXML_export_url');

														
		$oxyXML_permission = oxyXML_permissions();
		if ($oxyXML_permission > 2 || (!$oxyXML_active)) return;
				
		$home = get_option('home') . "/";
		
		$out = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>";
		$out .= "\n<urlset xmlns=\"http://www.sitemaps.org/schemas/sitemap/0.9\">\n<!-- Generated by oxyXML ".$oxyXML_version." plugin -->\n<!-- http://www.oxeron.com/category/open-source/wordpress-plugin-oxyxml -->\n<!-- Created ".date("F d, Y, H:i")."-->\n";
				
		$query = "SELECT
				".($oxyXML_export_excerpt?"`".$t."posts`.`post_excerpt`,":"")."
				".($oxyXML_export_content?"`".$t."posts`.`post_content`,":"")."
				".($oxyXML_export_date?"`".$t."posts`.`post_date`,":"")."
				".($oxyXML_export_title?"`".$t."posts`.`post_title`,":"")."
				".($oxyXML_export_category_id?"`".$t."term_taxonomy`.`term_id`,":"")."
				".($oxyXML_export_category_name?"`".$t."terms`.`name`,":"")."
				`".$t."posts`.`ID`, `".$t."posts`.`post_modified_gmt`, `".$t."posts`.`post_name`, `".$t."posts`.`post_type`				 
			FROM `".$t."posts`
			LEFT JOIN `".$t."term_relationships` ON `".$t."term_relationships`.`object_id` = `".$t."posts`.`ID`
			LEFT JOIN `".$t."terms` ON `".$t."terms`.`term_id` = `".$t."term_relationships`.`term_taxonomy_id`
			LEFT JOIN `".$t."term_taxonomy` ON `".$t."term_taxonomy`.`term_taxonomy_id` = `".$t."term_relationships`.`term_taxonomy_id` 
			WHERE
				`".$t."posts`.`post_status`='publish'
				AND (
					`".$t."posts`.`post_type`='page'
					OR `".$t."posts`.`post_type`='post'
				)
				AND `".$t."posts`.`post_title` != 'WPG2'
				".($oxyXML_categories?"AND `".$t."term_taxonomy`.term_id IN (".$oxyXML_categories.")":"")."
			GROUP BY `".$t."posts`.`ID`
			ORDER BY `".$t."posts`.`post_modified_gmt` DESC
		";		
		$now = time();
		$xDays = $oxyXML_delay*24*60*60;
		$result = $wpdb->get_results($query);
		
		ob_start();
		if (mysql_error()) {
			$wpdb->show_errors();
			$wpdb->print_error();
			$error = ob_get_contents();
		}
		ob_end_clean();

		if (count($result)) {
			$count = array();
			foreach($result as $post) {
				$postDate = strtotime($post->post_date);
                if ($now - $postDate < $xDays || ($oxyXML_count && $count[$post->term_id] < $oxyXML_count)) { 
                	$count[$post->term_id]++; 
                    $out .= "<post>".
                    ($oxyXML_export_url?"\n<url>".get_permalink($post->ID)."</url>":"").
                    ($oxyXML_export_category_name?"\n<category>".$post->name."</category>":"").
                    ($oxyXML_export_category_id?"\n<category_id>".$post->term_id."</category_id>":"").
                    ($oxyXML_export_title?"\n<title>".$post->post_title."</title>":"").
                    ($oxyXML_export_date?"\n<posted>".$post->post_date."</posted>":"").
                    ($oxyXML_export_excerpt?"\n<excerpt>".$post->post_excerpt."</excerpt>":"").
                    ($oxyXML_export_content==1?"\n<content><![CDATA[".trim($post->post_content)."]]></content>":"").
                    ($oxyXML_export_content==2?"\n<content><![CDATA[".trim(strip_tags($post->post_content))."]]></content>":"").
                    "\n</post>\n";
                }
			}
		}
		
		$out .= "\n</urlset>";

		if ($error != "") {     ?>
        		<div id="message" class="error"><p><strong><?php echo $error; ?></strong></p></div>
		<?php }
		
		if ($oxyXML_active && $oxyXML_permission != 1) {
			if (is_writable(ABSPATH . $oxyXML_path . "posts.xml")) {
				$fp = fopen(ABSPATH . $oxyXML_path . "posts.xml", 'w');
				if (fwrite($fp, $out) === FALSE) {
			        $msg="Unable to write data to file ".ABSPATH . $oxyXML_path . "posts.xml";
			        exit;
			    }
				fclose($fp);
			} else $msg="Error: File ".ABSPATH . $oxyXML_path . "posts.xml is not writeable";
		}
		
	}

	function oxyXML_admin_page() {
		global $oxyXML_version, $table_prefix,$msg,$wpdb;
		$t = $table_prefix;
		
		$msg = "";
		if ('oxyXML_submit' == $_POST['oxyXML_submit']) {
			update_option('oxyXML_active', $_POST['oxyXML_active']);
			update_option('oxyXML_export_excerpt', $_POST['oxyXML_export_excerpt']);
			update_option('oxyXML_export_content', $_POST['oxyXML_export_content']);			
			update_option('oxyXML_export_date', $_POST['oxyXML_export_date']);
			update_option('oxyXML_export_title', $_POST['oxyXML_export_title']);
			update_option('oxyXML_export_category_id', $_POST['oxyXML_export_category_id']);
			update_option('oxyXML_export_category_name', $_POST['oxyXML_export_category_name']);
			update_option('oxyXML_export_url', $_POST['oxyXML_export_url']);
			if (is_array($_POST['oxyXML_categories_tab']))
				update_option('oxyXML_categories', implode(',',$_POST['oxyXML_categories_tab']));
			else
				update_option('oxyXML_categories','');
				
			if ($_POST['oxyXML_count']>0) {
				update_option('oxyXML_count', $_POST['oxyXML_count']);	
				update_option('oxyXML_delay', "");
			} else {
				update_option('oxyXML_count', "");	
				update_option('oxyXML_delay', $_POST['oxyXML_delay']);	
			}		
			$newPath = trim($_POST['oxyXML_path']);
			if ($newPath == "" || $newPath == "/") $newPath = "./";
			elseif ($newPath[strlen($newPath)-1] != "/") $newPath .= "/";
			update_option('oxyXML_path', $newPath);					
			oxyXML_generate_xml();
		}
		$oxyXML_active = get_option('oxyXML_active');
		$oxyXML_categories = get_option('oxyXML_categories');
		$oxyXML_path = get_option('oxyXML_path');
		$oxyXML_delay = get_option('oxyXML_delay');
		$oxyXML_count = get_option('oxyXML_count');		
		$oxyXML_export_excerpt = get_option('oxyXML_export_excerpt');
		$oxyXML_export_content = get_option('oxyXML_export_content');	

		$oxyXML_export_date = get_option('oxyXML_export_date');
		$oxyXML_export_title = get_option('oxyXML_export_title');
		$oxyXML_export_category_id = get_option('oxyXML_export_category_id');
		$oxyXML_export_category_name = get_option('oxyXML_export_category_name');				
		$oxyXML_export_url = get_option('oxyXML_export_url');	
				
		$oxyXML_permission = oxyXML_permissions();
		if ($oxyXML_permission == 1) $msg = "Error: there is a problem with <em>posts.xml</em>. It doesn't exist or is not writable.";
	?>
	<div class="wrap">
<?php	if ($msg) {	?>
	<div id="message" class="error"><p><strong><?php echo $msg; ?></strong></p></div>
<?php	}	?>

<div id="dropmessage" class="updated" style="display:none;"></div>
<div class="wrap">
<h2>oxyXML - generates XML file with your posts</h2>
<p>
This is version <?=$oxyXML_version?>
&nbsp;&nbsp;<a target="_blank" title="" href="http://www.oxeron.com/category/open-source/wordpress-plugin-oxyxml">Visit plugin homepage (FR)
</a>
| <a target="_blank" title="" href="http://www.oxeron.com/">Visit company website (FR)</a>
| <a target="_blank" title="" href="http://www.oxeron.com/blog/">Visit company blog (FR)</a>
| <a target="_blank" title="" href="https://www.paypal.com/cgi-bin/webscr?cmd=_donations&business=paypal%40oxeron%2ecom&item_name=oxyXML&item_number=Support%20Open%20Source&no_shipping=0&no_note=1&tax=0&currency_code=USD&lc=US&bn=PP%2dDonationsBF&charset=UTF%2d8">Donate</a>
</p>

		<form name="form1" method="post" action="<?php echo $_SERVER["REQUEST_URI"]; ?>&amp;updated=true">
			<input type="hidden" name="oxyXML_submit" value="oxyXML_submit" />
			<h3>XML settings</h3>
			
			<table class="form-table">
				<tr valign="top">
					<th scope="row"><label for="oxyXML_active">Create XML file</label></th>
					<td>
						
							
<input name="oxyXML_active" type="checkbox" id="oxyXML_active" value="1" <?php echo $oxyXML_active?'checked="checked"':''; ?> />&nbsp;Check this box to generate posts.xml each time you add a post to your blog
													
					</td>
				</tr>
				<tr valign="top">
					<th scope="row"><label for="oxyXML_categories">List of categories</label></th>
					<td>
					Check the box corresponding to the categories of posts you want to export in the XML:<br/>
			<?php
			$oxyXML_categories_tab = explode(',',$oxyXML_categories);
			
			$query = "SELECT
				`".$t."term_taxonomy`.`term_id`, `".$t."term_taxonomy`.`parent`, `".$t."term_taxonomy`.`description`, `".$t."terms`.`name`
			FROM `".$t."term_taxonomy`, `".$t."terms`

			WHERE
				`".$t."term_taxonomy`.`taxonomy`='category'
				AND `".$t."terms`.`term_id` = `".$t."term_taxonomy`.`term_id`
			ORDER BY `".$t."term_taxonomy`.`term_id` ASC, `".$t."term_taxonomy`.`parent` ASC
			";	
			$result = $wpdb->get_results($query);
			ob_start();
			if (mysql_error()) {
				$wpdb->show_errors();
				$wpdb->print_error();
				$error = ob_get_contents();
			}
			ob_end_clean();
	
			if (count($result)) {
				foreach($result as $cat) {
	                        $out .= "<input type=\"checkbox\" name=\"oxyXML_categories_tab[".$cat->term_id."]\" value=\"".$cat->term_id."\" ".(in_array($cat->term_id,$oxyXML_categories_tab)?"checked=checked":"")."> ".$cat->name.($cat->description?" (<i>".$cat->description."</i>)":"")."<br>";
	
				}
				echo $out;
			}	
	
			?>
						
					</td>
				</tr>	
			</table>
			
			<h3>Number of posts to export</h3>
			
			<table class="form-table">			
				<tr valign="top">
					<th scope="row"><label for="oxyXML_delay">Do not export posts older than</label> </th>
					<td>						
							<input name="oxyXML_delay" type="text" id="oxyXML_delay" value="<?php echo $oxyXML_delay?>" /> days
							<br/>Posts older than this will not be exported to the XML.						
					</td> 
				</tr>	
				<tr valign="top">
					<th scope="row"><label for="oxyXML_count"><b>OR</b> export a maximum of</label> </th>
					<td>						
							<input name="oxyXML_count" type="text" id="oxyXML_count" value="<?php echo $oxyXML_count?>" /> posts per category
							<br/>If you want a minimal number of posts per category in your XML file, provide it here.<br/><b>If you provide a value > 0 for this parameter, the above one will be discarded.</b>						
					</td>
				</tr>										
			</table>

			<h3>Choose what to export in the XML</h3>
			
			<p>You can choose the informations which will be exported to your posts.xml</p>
			<table class="form-table">
				<tr valign="top">
					<th scope="row"><label for="oxyXML_export_date">Export the post date</label> </th>
					<td>						
							<input name="oxyXML_export_date" type="checkbox" id="oxyXML_export_date" value="1" <?php echo $oxyXML_export_date?'checked="checked"':''; ?> />&nbsp;Date will be exported like "2009-04-20 10:25:45"					
					</td> 
				</tr>	
				<tr valign="top">
					<th scope="row"><label for="oxyXML_export_category_id">Export the category ID</label> </th>
					<td>						
							<input name="oxyXML_export_category_id" type="checkbox" id="oxyXML_export_category_id" value="1" <?php echo $oxyXML_export_category_id?'checked="checked"':''; ?> />				
					</td> 
				</tr>
				<tr valign="top">
					<th scope="row"><label for="oxyXML_export_category_name">Export the category name</label> </th>
					<td>						
							<input name="oxyXML_export_category_name" type="checkbox" id="oxyXML_export_category_name" value="1" <?php echo $oxyXML_export_category_name?'checked="checked"':''; ?> />				
					</td> 
				</tr>
				<tr valign="top">
					<th scope="row"><label for="oxyXML_export_title">Export the post title</label> </th>
					<td>						
							<input name="oxyXML_export_title" type="checkbox" id="oxyXML_export_title" value="1" <?php echo $oxyXML_export_title?'checked="checked"':''; ?> />				
					</td> 
				</tr>	
				<tr valign="top">
					<th scope="row"><label for="oxyXML_export_url">Export the post url</label> </th>
					<td>						
							<input name="oxyXML_export_url" type="checkbox" id="oxyXML_export_url" value="1" <?php echo $oxyXML_export_url?'checked="checked"':''; ?> />				
					</td> 
				</tr>																				
				<tr valign="top">
					<th scope="row"><label for="oxyXML_export_excerpt">Export the post excerpt</label> </th>
					<td>						
							<input name="oxyXML_export_excerpt" type="checkbox" id="oxyXML_export_excerpt" value="1" <?php echo $oxyXML_export_excerpt?'checked="checked"':''; ?> />					
					</td> 
				</tr>	
				<tr valign="top">
					<th scope="row">Export the full post content</th>
					<td>						
							<input name="oxyXML_export_content" type="radio" id="oxyXML_export_content" value="1" <?php echo ($oxyXML_export_content==1)?'checked="checked"':''; ?> />&nbsp;Be aware that choosing this option can generate a large XML file. Consider reducing parameters in the "Number of posts to export" section above.			
					</td> 
				</tr>	
				<tr valign="top">
					<th scope="row"><b>OR</b> export the post content without HTML </th>
					<td>						
							<input name="oxyXML_export_content" type="radio" id="oxyXML_export_content_wo_html" value="2" <?php echo ($oxyXML_export_content==2)?'checked="checked"':''; ?> />&nbsp;Be aware that choosing this option can generate a large XML file. Consider reducing parameters in the "Number of posts to export" section above.					
					</td> 
				</tr>	
				<tr valign="top">
					<th scope="row"><b>OR</b> do not export post content </th>
					<td>						
							<input name="oxyXML_export_content" type="radio" id="oxyXML_export_content_wo_html" value="0" <?php echo (!$oxyXML_export_content)?'checked="checked"':''; ?> />					
					</td> 
				</tr>																	
			</table>
						
			<h3>Advanced settings</h3>
			
			<table class="form-table">	
				<tr valign="top">
					<th scope="row"><label for="oxyXML_path">XML path</label> </th>
					<td>
						<input name="oxyXML_path" type="text" id="oxyXML_path" value="<?php echo $oxyXML_path?>" />
						<br />Where to export posts.xml file on your server relatively to blog's home. <br/>If your blog url is <?=get_bloginfo('url')?> and if you leave the default value "./" in this field, the xml file will be found at <a href="<?=get_bloginfo('url')?>/posts.xml"><?=get_bloginfo('url')?>/posts.xml</a><br/>If you want to export your posts in a folder called "exports", use "./exports" and the xml file will be found at <a href="<?=get_bloginfo('url')?>/exports/posts.xml"><?=get_bloginfo('url')?>/exports/posts.xml</a>
					</td>
				</tr>
			</table>
			<p class="submit">
				<input type="submit" value="Save &amp; Rebuild" />
			</p>
		</form>
		
		<h3>Howto use the file posts.xml to display your posts on another website</h3>
		
		<p>Here is an example of posts.xml content:<br/>
		<textarea cols="80" rows="22">
<?php echo <<<EOF
<?xml version="1.0" encoding="UTF-8"?>
<urlset xmlns="http://www.sitemaps.org/schemas/sitemap/0.9">
<!-- Generated by oxyXML 0.2 plugin -->
<!-- http://www.oxeron.com/category/open-source/wordpress-plugin-oxyxml -->
<!-- Created April 28, 2009, 12:22-->
<post>
<url>http://www.oxeron.com/2009/04/20/comment-demander-poliment-a-ses-visiteurs-de-mettre-a-jour-ie6</url>
<category>Développement PHP/MySQL/jQuery</category>
<category_id>4</category_id>
<posted>2009-04-20 10:25:45</posted>
<title>Comment demander poliment à ses visiteurs de mettre à jour IE6</title>
</post>
<post>
<url>http://www.oxeron.com/2009/04/06/prendre-des-snapshots-dune-page-web-complete-sous-macosx</url>
<category>MacOSX</category>
<category_id>5</category_id>
<posted>2009-04-06 16:42:46</posted>
<title>Prendre des snapshots d'une page web complète sous MacOSX</title>
</post>
</urlset>
EOF;
?>
</textarea>

</p>
		<p><a href="http://www.oxeron.com/2009/02/20/oxyxml-01-wordpress-plugin">You can find a PHP example code on my blog (FR) to help you display your posts on another website</a></p>
		<p>You can see the result on these websites (in the right column):
		<br/>- <a href="http://www.oxyweb.com" target="_blank">Oxyweb.com (FR)</a>
		<br/>- <a href="http://www.websms.lu" target="_blank">Websms.lu (FR)</a>
		</p>
				
	</div>
<?php
	}
?>
